/*
 *	Encode and decode strings to a buffer
 */



#include "sifs.h"



int str_encode( u_int8_t* buffer, char* string )
{
	int len = strlen( string ) + 1;

	if( len > 1024 ) {
		return -ENAMETOOLONG;
	}

	PUT_16BIT( buffer, len );
	memcpy( buffer + 2, string, len );

	return len + 2;
}


int str_decode( u_int8_t* buffer, char** string )
{
	int len = GET_16BIT( buffer );

	if( len > 1024 ) {
		return -ENAMETOOLONG;
	}

	*string = (char*) buffer + 2;
	string[len] = '\0';   // Only to be sure the string ends here

	return len;
}
