/*
 *	Common definitions and error codes
 */



#ifndef SIFS_COMMON_H
#define SIFS_COMMON_H


/*
 * Debugging and profiling macros
 */

#ifdef SIFS_DEBUG
#define SIFS_DEBUG(x) fprintf( stderr, "%s", x )
#else
#define SIFS_DEBUG(x)
#endif

#ifdef SIFS_PROFILE
#define SIFS_PROFILE(x) fprintf( stderr, "%s", x )
#else
#define SIFS_PROFILE(x)
#endif


/*
 *	Known Opcodes
 */

#define SIFS_MOUNT					1
#define SIFS_UNMOUNT				2
#define SIFS_STATFS					3
#define SIFS_OPEN						258
#define SIFS_CREATE					259
#define SIFS_MKDIR					260
#define SIFS_MKNOD					261
#define SIFS_RELEASE					262
#define SIFS_UNLINK					263
#define SIFS_RMDIR					264
#define SIFS_LINK						265
#define SIFS_SYMLINK					266
#define SIFS_READLINK				267
#define SIFS_RENAME					268
#define SIFS_TRUNCATE				269
#define SIFS_GETATTR				270
#define SIFS_SETATTR					271
#define SIFS_READDIR					272
#define SIFS_READ						273
#define SIFS_WRITE						274
#define SIFS_FSYNC					275
#define SIFS_LOCK						276


/*
 *	Known error codes
 */

#define SIFS_EOK						0
#define SIFS_ESERVER					-1
#define SIFS_ENOTSUP				-2
#define SIFS_ENAMETOOLONG	-3
#define SIFS_ENOENT					-4
#define SIFS_EEXIST						-5
#define SIFS_ENOTEMPTY			-6
#define SIFS_EPERM						-7
#define SIFS_ETEMP						-8
#define SIFS_EACCES					-9
#define SIFS_EINVAL					-10
#define SIFS_ENOSPC					-11
#define SIFS_EIO							-12
#define SIFS_EPROTO					-13

#endif
