/*
 *	Process requests and send replys
 */



#include "sifs-server.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/vfs.h>
#include <unistd.h>
#include <dirent.h>
#include <fcntl.h>


#ifndef SIFS_PROCESS_H
#define SIFS_PROCESS_H

/*
 *	Helper functions used by the functions below
 */

int sifs_invalidcmd( struct connection* conn );
ssize_t not_implemented( struct connection* conn );
ssize_t consume_packet( int fd, u_int8_t* buffer, size_t bufsize, size_t packetlen );


/*
 *	Process valid requests and send the reply back to the client
 */

int sifs_mount( struct connection* conn );
int sifs_unmount( struct connection* conn );
int sifs_statfs( struct connection* conn );
int sifs_open( struct connection* conn );
int sifs_create( struct connection* conn );
int sifs_mkdir( struct connection* conn );
int sifs_mknod( struct connection* conn );
int sifs_release( struct connection* conn );
int sifs_unlink( struct connection* conn );
int sifs_rmdir( struct connection* conn );
int sifs_link( struct connection* conn );
int sifs_symlink( struct connection* conn );
int sifs_readlink( struct connection* conn );
int sifs_rename( struct connection* conn );
int sifs_truncate( struct connection* conn );
int sifs_getattr( struct connection* conn );
int sifs_setattr( struct connection* conn );
int sifs_readdir( struct connection* conn );
int sifs_read( struct connection* conn );
int sifs_write( struct connection* conn );
int sifs_fsync( struct connection* conn );
int sifs_lock( struct connection* conn );

#endif
