/*
 *	SIFS OpenSSH Server Module
 */



#include <stdio.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include "sifs-common.h"
#include "atomicio.h"
#include "getput.h"



#ifndef SIFS_SERVER_H
#define SIFS_SERVER_H


#define MAXBUFSIZE	8192

struct sc {
	int fd;
	size_t avail;
	u_int8_t buffer[MAXBUFSIZE];
};

struct connection {
	char mntpath[1024];
	struct sc in;
	struct sc out;
};


/*
 *	Close all open file descriptor
 *
 *	conn: Pointer to an allocated struct connection where the fds are stored
 */

void closefd( struct connection* conn );

#endif
