#include "strings.h"
#include <stdio.h>


int str_encode( u_int8_t* buffer, char* string )
{
	int len = strlen( string ) + 1;

	if( len > 1024 ) {
		return SIFS_ENAMETOOLONG;
	}

	PUT_16BIT( buffer, len );
	memcpy( buffer + 2, string, len );
	buffer[1+len] = '\0';

	return len + 2;
}


int str_decode( u_int8_t* buffer, char** string )
{
	int len = GET_16BIT( buffer );  // '\0' inclusive

	if( len > 1024 ) {
		return SIFS_ENAMETOOLONG;
	}

	buffer[1+len] = '\0';   // Only to be sure the string ends there
	*string = (char*) buffer + 2;

	return len;
}
