/*
 *	Encode and decode strings to a buffer
 */


#include <errno.h>
#include <sys/types.h>
#include "sifs-common.h"
#include "getput.h"



#ifndef STRINGS_H
#define STRINGS_H


/*
 *	Writes an given string including the \0 characterto the buffer with the
 *	size of this string  in front of it. The calling function is responsible for
 *	allocating the buffer and the buffer must be big enough to store the string
 *	and the size of it.
 *
 *	buffer: allocated memory where the string should be stored
 *	string: pointer to the beginning of the string
 *
 *	Returns the size of the string including the \0 character + two bytes on
 *	sucess or -1 on error
 */

int str_encode( u_int8_t* buffer, char* string );


/*
 *	Stores the pointer to the first character of the string in the parameter
 *	string and retruns its size.
 *
 *	buffer: memory where the string is stored
 *	string: pointer to another pointer where the beginning of the string will be stored
 *
 *	Returns the size of the string including the \0 character + two bytes on
 *	success or -1 on error
 */

int str_decode( u_int8_t* buffer, char** string );

#endif
